<template>
  <div class="wrapper-leaderboard">
    <div class="input-wrapper">
      <img src="@/assets/images/search.svg" loading="lazy" class="search-img" />
      <input
        type="text"
        v-model="input"
        :placeholder="$t('pages.leaderboard.ranking_search_input')"
        class="input"
      />
      <button v-if="input.length > 0" class="close-input" @click="input = ''">
        <img src="@/assets/images/cross.svg" loading="lazy" />
      </button>
    </div>
    <div class="leaderboard-header">
      <div class="number">#</div>
      <div class="field">{{ $t('pages.leaderboard.ranking_name') }}</div>
      <div class="field">{{ $t('pages.leaderboard.ranking_instance') }}</div>
      <div class="field">{{ $t('pages.leaderboard.ranking_pictures') }}</div>
    </div>
    <ul class="leaderboard-list">
      <li v-for="contributor in filteredList()" class="leaderboard-item">
        <div v-if="contributor.rank === 1" class="number">
          <img
            src="@/assets/images/or-medal.svg"
            loading="lazy"
            class="number-medal"
          />
        </div>
        <div v-else-if="contributor.rank === 2" class="number">
          <img
            src="@/assets/images/silver-medal.svg"
            loading="lazy"
            class="number-medal"
          />
        </div>
        <div v-else-if="contributor.rank === 3" class="number">
          <img
            src="@/assets/images/bronze-medal.svg"
            loading="lazy"
            class="number-medal"
          />
        </div>
        <div v-else class="number">
          <span>{{ contributor.rank }}</span>
        </div>
        <div class="field field-link">
          <Link
            :text="contributor.name"
            :url="`https://api.panoramax.xyz/#focus=map&map=9&users=${contributor.id}`"
            :title="$t('pages.leaderboard.title_link')"
            type="external"
            target="_blank"
            look="link--blue underline"
          >
            <template v-slot:external>
              <img
                src="@/assets/images/external-link-blue-dark.svg"
                loading="lazy"
                class="external-img"
              />
            </template>
          </Link>
        </div>
        <div class="field">
          <span>{{ contributor.instance_name }}</span>
        </div>
        <div class="field">
          <span v-if="contributor.nb_items.toString().length > 6">
            {{ `${formatNumber(contributor.nb_items)} millions` }}
          </span>
          <span v-else>{{ formatNumber(contributor.nb_items) }}</span>
        </div>
      </li>
    </ul>
  </div>
</template>

<script lang="ts" setup>
import { ref } from 'vue'
import { formatNumber } from '@/utils'
import Link from '@/components/Link.vue'
import type { StatsByContributor } from '@/interfaces/leaderboard'
const props = defineProps<{
  statsByContributors: StatsByContributor[]
}>()
let input = ref('')
function filteredList() {
  return props.statsByContributors.filter((item) =>
    item.name.toLowerCase().includes(input.value.toLowerCase())
  )
}
</script>

<style scoped lang="scss">
.wrapper-leaderboard {
  margin-top: 6rem;
}
.leaderboard-item,
.leaderboard-header {
  padding: 1.5rem;
  display: flex;
  align-items: center;
}
.leaderboard-item {
  border-bottom: 0.1rem solid var(--grey-pale);
}
.number {
  width: 5rem;
  margin-right: 4rem;
}
.leaderboard-header {
  border-bottom: 0.0625rem solid var(--grey-pale);
  padding: 2rem;
  color: var(--grey-dark);
  font-weight: bold;
}
.leaderboard-list {
  height: 50rem;
  overflow-y: scroll;
  margin-top: 1rem;
}
.input-wrapper {
  height: 4rem;
  width: 28rem;
  position: relative;
  margin-bottom: 2rem;
}
.search-img {
  height: 2rem;
  position: absolute;
  z-index: 1;
  left: 0.5rem;
  top: 0;
  bottom: 0;
  margin: auto 0;
}
.close-input {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 1.5rem;
  position: absolute;
  right: 0.5rem;
  top: 50%;
  transform: translate(0%, -50%);
  background-color: transparent;
  border: none;
  cursor: pointer;
}
.close-input img {
  height: 100%;
}
.input {
  height: 100%;
  width: 100%;
  border-radius: 0.5rem;
  border: 0.1rem solid var(--grey-semi-dark);
  padding-left: 2.7rem;
  padding-right: 2.5rem;
}
.field {
  width: 50%;
  margin-right: 2rem;
}
.field:last-child {
  text-align: right;
}
.leaderboard-header .field:last-child {
  margin-right: 3.5rem;
}
.number-medal {
  height: 2rem;
}
.external-img {
  height: 1rem;
}
@media (max-width: 500px) {
  .leaderboard-header,
  .leaderboard-item {
    font-size: 1.2rem;
    padding-right: 0;
    padding-left: 0;
  }
}
</style>
